﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Data.SqlServerCe;
using System.Data;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;
using TreeGridListHelper_cs;

public partial class _Default : System.Web.UI.Page
{
    private string[] codings = new string[] { "#9ba0c9", "#b5b9db", "#d4d6ee", "#e7eaf9" };
    private Hashtable StyleRenderStatus = new Hashtable();
    TreeGridListHelper_cs.TreeGridList treeGrid;
    

    SqlCeConnection myConnection = null;
    SqlCeDataAdapter myDataAdapter = null;
    DataSet myDataSet = null;

    string ConnectionString = @"Data Source=|DataDirectory|\Department.sdf";

    private void EnableColorCodings(GridTableCellStyleInfoEventArgs e)
    {
        int indent = (treeGrid.GetNode(e.TableCellIdentity.RowIndex)).Indent;
        if (codings.Length - 1 >= indent)
        {
            {
                e.Style.CssClass = string.Format("{0} Level{1}", e.Style.CssClass, indent);
                if (StyleRenderStatus[indent] == null)
                {
                    RenderStyle(string.Format(".Level{0}", indent), codings[indent]);
                    StyleRenderStatus.Add(indent, true);
                }
            }

        }
    }

    /// <summary>
    /// Function to get the expanded state of the row
    /// </summary>
    /// <param name="container"></param>
    /// <returns></returns>
    protected bool GetExpanded(GridCell container)
    {
        string name = string.Empty; ;
        int rowIndex = container.Row.Record.GetSourceIndex() + 2;

        return treeGrid.GetNode(rowIndex).IsExpanded;
    }

    protected bool GetPlusMinus(GridCell container)
    {
        int rowIndex = container.Row.Record.GetSourceIndex() + 2;
        return treeGrid.GetNode(rowIndex).HasChildren;
    }

    /// <summary>
    /// Function to get the level of the node
    /// </summary>
    /// <param name="container"></param>
    /// <returns></returns>
    protected int GetLevel(GridCell container)
    {

        int level = treeGrid.GetNode(container.Row.Record.GetSourceIndex() + 2).Indent;
        return level;
    }

    /// <summary>
    /// Function to get the name
    /// </summary>
    /// <param name="container"></param>
    /// <returns></returns>
    protected string GetName(GridCell container)
    {
        string name = string.Empty; ;
        Record rowRecord = container.Row.Record;
        if (rowRecord.GetValue("DEPTNO") != null)
            name = rowRecord.GetValue("DEPTNO").ToString();
        return name;
    }

    /// <summary>
    /// Function to get the row index
    /// </summary>
    /// <param name="container"></param>
    /// <returns></returns>
    protected int GetRowIndex(GridCell container)
    {
        return container.Row.Record.GetSourceIndex() + 2;
    }

    /// <summary>
    /// Event fired to apply the cell style
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
    {
        switch (e.TableCellIdentity.TableCellType)
        {
            case GridTableCellType.AlternateRecordFieldCell:
            case GridTableCellType.RecordFieldCell:
                {
                    e.Style.CssClass = "GridAnyRecord";
                    //if (CheckBox1.Checked)
                    //    EnableColorCodings(e);
                    break;
                }
            case GridTableCellType.ColumnHeaderCell:
                {
                    e.Style.CssClass = "HeaderGradient";
                    break;
                }
        }
    }

    protected void Page_Init(object sender, EventArgs e)
    {
        //To allow ASP.NET to use SQL Compact Server 3.5
        AppDomain.CurrentDomain.SetData("SQLServerCompactEditionUnderWebHosting", true);

        if (!IsPostBack)
        {
            Session.Clear();
            Session["state"] = 8;
        }

        treeGrid = this.Session["TreeGridHelper"] as TreeGridListHelper_cs.TreeGridList;
        if (treeGrid == null)
        {
            // Get the sample table with self-relations
            try
            {
                myConnection = new SqlCeConnection(ConnectionString);
                myDataAdapter = new SqlCeDataAdapter("SELECT ID, DEPTNO, DEPTNAME, MGR, ADMRDEBT, Location FROM dept", myConnection);
                myDataSet = new DataSet();
                myDataAdapter.Fill(myDataSet);
                DataTable myDataTable = myDataSet.Tables[0];

                treeGrid = new TreeGridListHelper_cs.TreeGridList(myDataTable, "ADMRDEBT", "ID", "DEPTNO");
                treeGrid.ColorCodeSiblings = false;//dont show colors           
                this.Session["TreeGridHelper"] = treeGrid;
            }
            catch (SqlCeException ex)
            {
                throw ex;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        treeGrid.WireSelfReferenceGrid(this.GridGroupingControl1);

    }

    /// <summary>
    /// Event fired when page gets unloaded
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Unload(object sender, EventArgs e)
    {
        if (treeGrid != null)
            treeGrid.UnwireGrid();
    }

    private void RenderStyle(string classname, string color)
    {
       // stylecontainer.InnerHtml += "<style>" + classname + "{background-color:" + color + "};}</style>";
    }


    /// <summary>
    /// Event fired on click of custom control
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="args"></param>
    protected void WebCustomControl1_1_Click(object sender, TreeGridListHelper.ClickEventArgs args)
    {
        if (args.Expanded == true)
            treeGrid.ExpandNode(args.RowIndex);
        else
            treeGrid.CollapseNode(args.RowIndex);
        this.GridGroupingControl1.ClearControlHierarchy();
    }

    protected void Page_Load(object sender, EventArgs e)
    {

    }
}
